///
/// HybridMultipleImagePickerSpec.hpp
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

#pragma once

#if __has_include(<NitroModules/HybridObject.hpp>)
#include <NitroModules/HybridObject.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif

// Forward declaration of `NitroConfig` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct NitroConfig; }
// Forward declaration of `PickerResult` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct PickerResult; }
// Forward declaration of `NitroCropConfig` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct NitroCropConfig; }
// Forward declaration of `CropResult` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct CropResult; }
// Forward declaration of `MediaPreview` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct MediaPreview; }
// Forward declaration of `NitroPreviewConfig` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct NitroPreviewConfig; }
// Forward declaration of `NitroCameraConfig` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct NitroCameraConfig; }
// Forward declaration of `CameraResult` to properly resolve imports.
namespace margelo::nitro::multipleimagepicker { struct CameraResult; }

#include "NitroConfig.hpp"
#include <functional>
#include <vector>
#include "PickerResult.hpp"
#include <string>
#include "NitroCropConfig.hpp"
#include "CropResult.hpp"
#include "MediaPreview.hpp"
#include "NitroPreviewConfig.hpp"
#include "NitroCameraConfig.hpp"
#include "CameraResult.hpp"

namespace margelo::nitro::multipleimagepicker {

  using namespace margelo::nitro;

  /**
   * An abstract base class for `MultipleImagePicker`
   * Inherit this class to create instances of `HybridMultipleImagePickerSpec` in C++.
   * You must explicitly call `HybridObject`'s constructor yourself, because it is virtual.
   * @example
   * ```cpp
   * class HybridMultipleImagePicker: public HybridMultipleImagePickerSpec {
   * public:
   *   HybridMultipleImagePicker(...): HybridObject(TAG) { ... }
   *   // ...
   * };
   * ```
   */
  class HybridMultipleImagePickerSpec: public virtual HybridObject {
    public:
      // Constructor
      explicit HybridMultipleImagePickerSpec(): HybridObject(TAG) { }

      // Destructor
      ~HybridMultipleImagePickerSpec() override = default;

    public:
      // Properties
      

    public:
      // Methods
      virtual void openPicker(const NitroConfig& config, const std::function<void(const std::vector<PickerResult>& /* result */)>& resolved, const std::function<void(double /* reject */)>& rejected) = 0;
      virtual void openCrop(const std::string& image, const NitroCropConfig& config, const std::function<void(const CropResult& /* result */)>& resolved, const std::function<void(double /* reject */)>& rejected) = 0;
      virtual void openPreview(const std::vector<MediaPreview>& media, double index, const NitroPreviewConfig& config, const std::function<void(double /* index */)>& onLongPress) = 0;
      virtual void openCamera(const NitroCameraConfig& config, const std::function<void(const CameraResult& /* result */)>& resolved, const std::function<void(double /* reject */)>& rejected) = 0;

    protected:
      // Hybrid Setup
      void loadHybridMethods() override;

    protected:
      // Tag for logging
      static constexpr auto TAG = "MultipleImagePicker";
  };

} // namespace margelo::nitro::multipleimagepicker
