///
/// Presentation.hpp
/// This file was generated by nitrogen. DO NOT MODIFY THIS FILE.
/// https://github.com/mrousavy/nitro
/// Copyright © 2025 Marc Rousavy @ Margelo
///

#pragma once

#if __has_include(<NitroModules/NitroHash.hpp>)
#include <NitroModules/NitroHash.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif
#if __has_include(<NitroModules/JSIConverter.hpp>)
#include <NitroModules/JSIConverter.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif
#if __has_include(<NitroModules/NitroDefines.hpp>)
#include <NitroModules/NitroDefines.hpp>
#else
#error NitroModules cannot be found! Are you sure you installed NitroModules properly?
#endif

namespace margelo::nitro::multipleimagepicker {

  /**
   * An enum which can be represented as a JavaScript union (Presentation).
   */
  enum class Presentation {
    FULLSCREENMODAL      SWIFT_NAME(fullscreenmodal) = 0,
    FORMSHEET      SWIFT_NAME(formsheet) = 1,
  } CLOSED_ENUM;

} // namespace margelo::nitro::multipleimagepicker

namespace margelo::nitro {

  using namespace margelo::nitro::multipleimagepicker;

  // C++ Presentation <> JS Presentation (union)
  template <>
  struct JSIConverter<Presentation> final {
    static inline Presentation fromJSI(jsi::Runtime& runtime, const jsi::Value& arg) {
      std::string unionValue = JSIConverter<std::string>::fromJSI(runtime, arg);
      switch (hashString(unionValue.c_str(), unionValue.size())) {
        case hashString("fullScreenModal"): return Presentation::FULLSCREENMODAL;
        case hashString("formSheet"): return Presentation::FORMSHEET;
        default: [[unlikely]]
          throw std::invalid_argument("Cannot convert \"" + unionValue + "\" to enum Presentation - invalid value!");
      }
    }
    static inline jsi::Value toJSI(jsi::Runtime& runtime, Presentation arg) {
      switch (arg) {
        case Presentation::FULLSCREENMODAL: return JSIConverter<std::string>::toJSI(runtime, "fullScreenModal");
        case Presentation::FORMSHEET: return JSIConverter<std::string>::toJSI(runtime, "formSheet");
        default: [[unlikely]]
          throw std::invalid_argument("Cannot convert Presentation to JS - invalid value: "
                                    + std::to_string(static_cast<int>(arg)) + "!");
      }
    }
    static inline bool canConvert(jsi::Runtime& runtime, const jsi::Value& value) {
      if (!value.isString()) {
        return false;
      }
      std::string unionValue = JSIConverter<std::string>::fromJSI(runtime, value);
      switch (hashString(unionValue.c_str(), unionValue.size())) {
        case hashString("fullScreenModal"):
        case hashString("formSheet"):
          return true;
        default:
          return false;
      }
    }
  };

} // namespace margelo::nitro
